# This is a custom build package for the course
# Shows extra diagnostic info
library(HomomorphicEncryption2)

p <- pars("FandV", d=32, qpow=24, t=32, sigma=3)
keys <- keygen(p)
ct <- enc(keys$pk, 3)

# What is the noise like initially and after ops?
dec(keys$sk, ct)
dec(keys$sk, ct+ct)
dec(keys$sk, ct*ct)

# Danger!  Coefficient outgrows t/2 and trouble
ct2 <- ct
for(i in 1:32) {
  ct2 <- ct2+ct
  print(dec(keys$sk, ct2))
}

# Danger!  Exceed degree?
# We can do one multiply
dec(keys$sk, ct*ct)
dec(keys$sk, ct*ct*ct)
# but not when the degree will spill over
ct <- enc(keys$pk, 100000)
dec(keys$sk, ct*ct)
